/*==========================================================================;
 *
 *  AUTHOR:     Subash, Agila
 *
 *  FILE NAME:  binary.cpp
 *
 *  CONTENTS:  Implementation of the class 'Binary'
 *
 *  DATE:      March 24, 2004
 ***************************************************************************/

#include "binary.h"


//----------------------constructor--------------------

Binary::Binary():nodeSrc(500, 2.0, 50000),stk(100)
{
	root = NULL;
	
}
//---------------------------------------------
AVLNode* Binary ::first()
{
	stk.clear();

	AVLNode *current = root;
	if (current== NULL)
		return current;
	while(current !=NULL)
	{
		stk.push(current);
		current = current->left;
	}

	return stk.getElement(0);
}

//------------------------------------------------------
AVLNode* Binary ::next()
{
	if(stk.getNumOfElements()==0)
		return NULL;

	AVLNode *current = (stk.pop())->right;

	while(current!=NULL)
	{
		stk.push(current);
		current = current->left;
	}

	if(stk.getNumOfElements() == 0) 
		return NULL;
	return(stk.getElement(0));
}


// TESTED OK. Still don't understand how it works.
//-------------------------------------------------------------------------
AVLNode * Binary::insert(int symbolNum,unsigned int atomNum)
{
	
//	bool inserted = false;
	int imbalance;

	AVLNode *fcurrent = NULL;
	AVLNode *current= root;
	AVLNode *fya = NULL;
	AVLNode *ya = current;
	AVLNode *q = NULL;
	AVLNode *s = NULL;


	AVLNode *n = nodeSrc.New();
	n->symbolNum = symbolNum;
	n->atomNum = atomNum;
	n->value=0;
	n->isHorn=0;
	n->hornRuleNum=0;
	n->firstRule=0;
	n->number=0;
	n->left = NULL;
	n->right = NULL;

	if (root == NULL)
	{
		n->balance = 0;				
		root = n;
	//	inserted = true;
		return root;

	}	

	while(current !=NULL)
	{

		if((symbolNum== current->symbolNum) && (atomNum == current->atomNum))
		{ nodeSrc.Delete(n); return current; }
		if((symbolNum < current->symbolNum ) ||
			((symbolNum== current->symbolNum) && (atomNum < current->atomNum)))
			q= current->left;
		else
			q= current->right;
		if(q!= NULL)
			if(q->balance !=0)
			{
				fya = current;
				ya = q;
			}//end if

			fcurrent = current;
			current = q;
	}//end while

	q= n;
	q->balance = 0;
	if((symbolNum < fcurrent->symbolNum ) ||
	  ((symbolNum== fcurrent->symbolNum) && (atomNum < fcurrent->atomNum)))
			fcurrent->left=q;
	else
		fcurrent->right = q;

	/* The balance on all nodes between node ya and node q must be changed
	from 0 */

	if((symbolNum < ya->symbolNum ) ||
	  ((symbolNum== ya->symbolNum) && (atomNum < ya->atomNum)))
	  	current= ya->left;
	else
		current= ya->right;


	s= current;
	while (current != q)
	{
		if((symbolNum < current->symbolNum ) ||
			((symbolNum== current->symbolNum) && (atomNum < current->atomNum)))
		{
			current->balance = 1;
			current = current->left;
		}
		else
		{
			current->balance =-1;
			current = current->right;
		}//end if
	}//end while



	/*Ascertain if the tree is unbalanced .If it is ,q is the newly inserted node.
	ya is its youngest unbalanced ancestor,fya is the father of ya
	and s is the son of ya in the direction of the imbalance*/

	if((symbolNum < ya->symbolNum ) ||
	  ((symbolNum== ya->symbolNum) && (atomNum < ya->atomNum)))
	  	imbalance = 1;
	else
		imbalance = -1;


	if(ya->balance ==0)
	{
		ya->balance = imbalance;
		return q;
	}
	if(ya->balance != imbalance)
	{
		ya->balance =0;
		return q;
	}


	if(s->balance == imbalance)
	{
		current = s;
		if(imbalance ==1)
			rotateRight(ya);
		else
			rotateLeft(ya);
		ya->balance = 0;
		s->balance =0;
	}

	else
	{
		if(imbalance == 1)
		{
			current = s->right;
			rotateLeft(s);
			ya->left = current;
			rotateRight(ya);
		}

		else
		{
			current = s->left;
			rotateRight(s);
			ya->right = current;
			rotateLeft(ya);
		}//end if

		if(current->balance ==0)
		{
			ya->balance = 0;
			s->balance =0;
		}
		else if(current->balance == imbalance)
			{
				ya->balance =-imbalance;
				s->balance = 0;
			}
			else
			{
				ya->balance = 0;
				s->balance =imbalance;
			}
			current->balance =0;
		}//end if

		if(fya == NULL)
			root = current;
		else if(ya == fya->right)
			fya->right = current;
		else
			fya->left = current;
		return q;
			
}




//-----------------------------------------------------------------------
void Binary::rotateLeft(AVLNode *p)
{
	AVLNode *q = p->right;
	AVLNode *hold = q->left;
	q->left = p;
	p->right = hold;

}

//-------------------------------------------------------------------
void Binary::rotateRight(AVLNode *p)
{
	AVLNode *q = p->left;
	AVLNode *hold = q->right;
	q->right = p;
	p->left = hold;

}
